unit NewGame;

interface

uses
  SysUtils, Forms, StdCtrls, ComCtrls, ExtCtrls, Dialogs, Controls, Classes;

type
  TNewGameForm = class(TForm)
    GField: TGroupBox;
    CCustomField: TRadioButton;
    LWidth: TLabel;
    EWidth: TEdit;
    CWidth: TUpDown;
    LHeight: TLabel;
    EHeight: TEdit;
    CHeight: TUpDown;
    CLoadField: TRadioButton;
    CSelectField: TComboBox;
    GPlayer1: TGroupBox;
    LName1: TLabel;
    EName1: TEdit;
    CHuman1: TRadioButton;
    CAgent1: TRadioButton;
    LAILevel1: TLabel;
    CAILevel1: TTrackBar;
    LColor1: TLabel;
    PColor1: TPanel;
    BOK: TButton;
    BCancel: TButton;
    ColorPicker: TColorDialog;
    GPlayer2: TGroupBox;
    LName2: TLabel;
    LAILevel2: TLabel;
    LColor2: TLabel;
    EName2: TEdit;
    CHuman2: TRadioButton;
    CAgent2: TRadioButton;
    CAILevel2: TTrackBar;
    PColor2: TPanel;
    LAILevel: TLabel;
    LAILevelDescription: TLabel;
    procedure PColorClick(Sender: TObject);
    procedure PlayerTypeClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FieldTypeClick(Sender: TObject);
    procedure CAILevelChange(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  NewGameForm: TNewGameForm;

implementation

uses
  RasterField;

{$R *.dfm}

procedure TNewGameForm.PColorClick(Sender: TObject);
begin
  with Sender as TPanel do begin
    ColorPicker.Color := Color;
    if not ColorPicker.Execute then exit;
    Color := ColorPicker.Color;
  end;
end;

procedure TNewGameForm.PlayerTypeClick(Sender: TObject);
var z: boolean;
begin
  z := CAgent1.Checked; LAILevel1.Enabled := z; CAILevel1.Enabled := z;
  z := CAgent2.Checked; LAILevel2.Enabled := z; CAILevel2.Enabled := z;
end;

procedure TNewGameForm.FormShow(Sender: TObject);
var OldField: string;
    Index: integer;
begin
  if CSelectField.ItemIndex < 0
    then OldField := ''
    else OldField := CSelectField.Items[CSelectField.ItemIndex];
  TRaster_ListSavedFields(CSelectField.Items);
  Index := CSelectField.Items.IndexOf(OldField);
  if Index >= 0 then CSelectField.ItemIndex := Index
                else CSelectField.ItemIndex := 0;
  LAILevel.Visible := false;
  LAILevelDescription.Visible := false;
  PlayerTypeClick(nil);
  FieldTypeClick(nil);
end;

procedure TNewGameForm.FieldTypeClick(Sender: TObject);
var z: boolean;
begin
  z := CCustomField.Checked;
  LWidth.Enabled := z;
  EWidth.Enabled := z;
  CWidth.Enabled := z;
  LHeight.Enabled := z;
  EHeight.Enabled := z;
  CHeight.Enabled := z;
  CSelectField.Enabled := not(z);
end;

procedure TNewGameForm.CAILevelChange(Sender: TObject);
begin
  LAILevel.Visible := true;
  LAILevelDescription.Visible := true;
  LAILevel.Caption := 'KI-Level '+IntToStr((Sender as TTrackBar).Position)+':';
  case (Sender as TTrackBar).Position of
    0: LAILevelDescription.Caption :=
         'zufllige Zge';
    1: LAILevelDescription.Caption :=
         'optimale Zge defensiv';
    2: LAILevelDescription.Caption :=
         'optimale Zge offensiv';
    3: LAILevelDescription.Caption :=
         'optimale Zge im Mittel';
    4: LAILevelDescription.Caption :=
         'MiniMax-Strategie';
    5: LAILevelDescription.Caption :=
         'MiniMax-Strategie mit Alpha-Beta-Pruning';
  end;
end;

procedure TNewGameForm.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Key=#27 then ModalResult:=mrCancel;
end;

end.
